/*
    ------------------------------------------------------------------------------------
    LICENSE:
    ------------------------------------------------------------------------------------
    This file is part of EVEmu: EVE Online Server Emulator
    Copyright 2006 - 2021 The EVEmu Team
    For the latest information visit https://evemu.dev
    ------------------------------------------------------------------------------------
    This program is free software; you can redistribute it and/or modify it under
    the terms of the GNU Lesser General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any later
    version.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
    FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 59 Temple
    Place - Suite 330, Boston, MA 02111-1307, USA, or go to
    http://www.gnu.org/copyleft/lesser.txt.
    ------------------------------------------------------------------------------------
    Author:        Zhur
*/


#ifndef __NET_H_INCL__
#define __NET_H_INCL__

#include "PyService.h"

class NetService : public PyService {
public:
    NetService(PyServiceMgr *mgr);
    ~NetService();

protected:
    class Dispatcher;
    Dispatcher *const m_dispatch;

    PyCallable_DECL_CALL(GetInitVals);
    PyCallable_DECL_CALL(GetTime);
    PyCallable_DECL_CALL(GetClusterSessionStatistics);

};

#endif

/*
 _ _replacese*rvice__ = 'machoNet'
 __gpcsmethodnames__ = ['Broadcast',
 'ClusterBroadcast',
 'ConnectToAllNeighboringServices',
 'ConnectToAllServices',
 'ConnectToAllSiblingServices',
 'ConnectToRemoteService',
 'NarrowcastByAllianceIDs',
 'NarrowcastByCharIDs',
 'NarrowcastByClientIDs',
 'NarrowcastByClientIDsWithoutTheStars',
 'NarrowcastByCorporationIDs',
 'NarrowcastByFleetIDs',
 'NarrowcastByNodeIDs',
 'NarrowcastByShipIDs',
 'NarrowcastBySolarSystemID2s',
 'NarrowcastBySolarSystemIDs',
 'NarrowcastByStationIDs',
 'NarrowcastByStationID2s',
 'NarrowcastByUserIDs',
 'NarrowcastToClientAndObservers',
 'NarrowcastToObservers',
 'SinglecastByServiceMask',
 'NodeBroadcast',
 'Objectcast',
 'ObjectcastWithoutTheStars',
 'OnObjectPublicAttributesUpdated',
 'ProxyBroadcast',
 'Queuedcast',
 'QueuedcastWithoutTheStars',
 'ReliableSinglecastByCharID',
 'ReliableSinglecastByUserID',
 'RemoteServiceCall',
 'RemoteServiceCallWithoutTheStars',
 'RemoteServiceNotify',
 'RemoteServiceNotifyWithoutTheStars',
 'ResetAutoResolveCache',
 'Scattercast',
 'ScattercastWithoutTheStars',
 'ServerBroadcast',
 'SinglecastByAllianceID',
 'SinglecastByCharID',
 'SinglecastByClientID',
 'SinglecastByCorporationID',
 'SinglecastByFleetID',
 'SinglecastByNodeID',
 'SinglecastByShipID',
 'SinglecastBySolarSystemID',
 'SinglecastBySolarSystemID2',
 'SinglecastByStationID',
 'SinglecastByStationID2',
 'SinglecastByUserID',
 'SinglecastByWorldSpaceID']
 __server_scattercast_session_variables__ = ('userid',
 'charid',
 'shipid',
 'objectID',
 'fleetid',
 'wingid',
 'squadid')

     */